LeetCode第1题:两数之和

题目来源:https://leetcode-cn.com/problems/two-sum/

题目描述:

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。
示例:
给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

解法

方法一:暴力求解-枚举

public class Solution {
	public int[] twoSum(int[] nums, int target) {
		// 赋值数组长度
		int len = nums.length;
		for (int i = 0; i < len; ++i) {
			for (int j = i + 1; j < len; ++j) {
				if (nums[i] + nums[j] == target) {
					// 返回新数组
					return new int[]{i, j};
				}
			}
		}
		// 抛出异常或返回任意数组
		// throw new IllegalArgumentException("No two sum solution");
		return new int[0];
	}
}

时间复杂度:O(N2)
空间复杂度:O(1)

方法二:查找表法-哈希表(不需要考虑元素顺序)

public class Solution {
    public int[] twoSum(int[] nums, int target) {
        int len = nums.length;
		//初始化哈希表,指定哈希表容量来避免哈希表扩容带来性能消耗
		Map<Integer, Integer> hashMap = new HashMap<>();
		//第一个元素在其之前没有元素对应,将元素和下标存入哈希表中
		hashMap.put(nums[0], 0);
		//在第二个元素开始遍历
		for (int i = 1; i < nums.length; ++i) {
			//判断与新元素相对应的target - nums[i]元素是否在哈希表中
			if (hashMap.containsKey(target - nums[i])) {
				//在,返回两个元素的下标
				return new int[]{hashMap.get(target - nums[i]), i};
			}
			//不在,将当前的元素及其下标存入哈希表
			hashMap.put(nums[i], i);
		}
		throw new IllegalArgumentException("No two sum solution");
    }
}

时间复杂度:O(n)
空间复杂度:O(n)

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值